/*******************************************************************
 *
 *		blueTicTacToe
 *		(C) 2003 - Thomas Unterthiner
 *
 *		a classic TicTacToe-Game
 *
 *******************************************************************
 *
 *	CTicTacToe.h
 *	declaration for the CTicTacToe-Class, the main Game-Class
 *
 *******************************************************************
 *
 *	This program is free software; you can redistribute it and/or 
 *	modify it under the terms of the GNU General Public License as 
 *	published by the Free Software Foundation; either version 2 of 
 *	the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public 
 *	License along with this program; if not, write to the 
 *
 *	Free Software Foundation, Inc.,
 *	59 Temple Place,Suite 330,
 *	Boston, MA 02111-1307,
 *	USA
 *
 *******************************************************************/

#ifndef blueTicTacToe_CTicTacToe_h
#define blueTicTacToe_CTicTacToe_h

#include "CGrid.h"

#include <iostream>
using namespace std;

class CTicTacToe
{
 private:
	CGrid<char>	GameGrid;
	char*	Player1;
	char*	Player2;
	short	grid_size;

	bool makeMove(short row, short column, char Sign);
	// makes a move (marks a field), if it is still free
	// RETURN: false if field could not be marked

	int checkForWins();
	// checks if someone has already won, by counting the fieldsums in every row/column/diagonal line
	// RETURN: PlayerNr of the winner, 0 if nobody has won yet


 public:

	CTicTacToe():GameGrid(3,3)
	// ctor
	{
	};

	CTicTacToe(short GridSize):GameGrid(GridSize, GridSize)
	// ctor with dynamical GridSize
	{
		grid_size = GridSize;
	};

	void play();
	// main game-execution
	
};

#endif
